---
title: "Kubernetes at the Far Edge: Harnessing IoT with Lightweight Clusters and Akri"
weight: 5
tags:
 - rejekts
 - edge
---

{{% button href="https://www.youtube.com/watch?v=jywpFlOH3z0" style="warning" icon="video" %}}Watch talk on YouTube{{% /button %}}
<!-- {{% button href="https://docs.google.com/presentation/d/1nEK0CVC_yQgIDqwsdh-PRihB6dc9RyT-" style="tip" icon="person-chalkboard" %}}Slides{{% /button %}} -->

## The far edge

- Resource constraint computing
- Limited connectivity
- More and smaller clusters

## Why kubernetes

- Automation, Scalability and resilience
- Workload Portability through containers
- Orchestration
- Declarative state

## Enter k0s

- Minimal footprint as static binary
- Simplified edge cluster management

## Managing disconnected edge nodes

- Needs: Remote managability
- Idea: Centralized, remote Control Plane (that only does control plane)
- Challenge: Network disconnections (kubernetes usually moves workload)

## Akri

> https://docs.akri.sh/

- Discovery of iot devices
- Exposes IoT devices as k8s resources
- Handels workload scheduling for leaf devices

![](../_imgs/akri-architecture.svg)


## Demo

Can be found in the video

## Q&A

- What about image distribution: Depends on networking conditions, k0s supports interna. images delivered as tar.gz
- What can the broker do: Anything that a pod can interact with
- What about reboots: Well akri had some problems in the demo, kubelet seems to start the containers again

## Random Notes

- Akri Kinda reminded me of the gpu-operator with extra resouce capacity for attached devices